# Client_Pre_Command_Handler is called when an action is received from
# a FOP2 Client (from the browser), like changing the presence, initiating
# a transfer, etc. You also can return an AMI command to be sent. 
# The Pre handler will issue your commands BEFORE the standard FOP2
# response. The Post handler will issue the commands AFTER the standard
# FOP2 response.
#
# The first key is the name of the plugin, the second the action received
# from a FOP2 client. You can catch here custom actions defined in the .js
# part of a plugin too.
#
# A good way to see the commands that can be recieved from the client is
# to start fop2_server in debug level 4: /usr/local/fop2/fop2_server -X 4
#
$Client_Post_Command_Handler{'pauseonlogout'}{'auth'} = sub {


    my $origen     = shift;
    my $destino    = shift;
    my $contexto   = shift;
    my $socket     = shift;
    my $logsuccess = shift;
    my $ip_port    = shift;
    my @allreturn;

    if($logsuccess==1) {

        my $channel   = main::get_btn_channel ("$contexto",$destino);
        my $pos       = main::get_btn_position("$contexto",$channel);
        my $queuechan = main::get_btn_config  ("$contexto",$pos,'QUEUECHANNEL');
        my ($member, undef) = split(/\|/,$queuechan);
        print "unpause $contexto $destino $channel $pos $queuechan $member\n";

        $return  = "Action: QueuePause\r\n";
        $return .= "Interface: $member\r\n";
        $return .= "Paused: 0\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        return @allreturn;
    }
};

$Client_Pre_Command_Handler{'pauseonlogout'}{'logoff'} = sub {
    my $origen     = shift;
    my $destino    = shift;
    my $contexto   = shift;
    my $socket     = shift;
    my $extension  = shift;
    my @allreturn;

    my $reason = defined($main::pluginconfig{'pauseonlogout'}{'pause_reason'}{''})?$main::pluginconfig{'pauseonlogout'}{'pause_reason'}{''}:'';

    my $channel   = main::get_btn_channel ("$contexto",$destino);
    my $pos       = main::get_btn_position("$contexto",$channel);
    my $queuechan = main::get_btn_config  ("$contexto",$pos,'QUEUECHANNEL');
    my ($member, undef) = split(/\|/,$queuechan);

    print "pause $contexto $destino $channel $pos $queuechan $member\n";

    $return  = "Action: QueuePause\r\n";
    $return .= "Interface: $member\r\n";
    $return .= "Paused: 1\r\n";
    $return .= "Reason: $reason\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    return @allreturn;
};

